import { Meta, Canvas, Story, ArgsTable } from '@storybook/addon-docs/blocks';
import { defaultLayout } from '../.storybook/decorators';
import BlockMultiColumnLayout from './block-multi-column-layout';
import store from '@/.storybook/store';
import { addControls, initJsonKnobs } from '@/.storybook/helpers';

export const argTypes = {
	contentIconPosition: {
		control: {
			type: 'select',
			options: ['top', 'middle', 'bottom'],
		},
	},
	ctaVariant: {
		control: {
			type: 'select',
			options: ['', 'arrow', 'Outline'],
		},
	},
	textAlignDesktop: {
		control: {
			type: 'select',
			options: ['left', 'center', 'right'],
		},
	},
	textAlignMobile: {
		control: {
			type: 'select',
			options: ['left', 'center', 'right'],
		},
	},
	variantMobile: {
		control: {
			type: 'select',
			options: ['Image first', 'Content first'],
		},
	},
};

export const controls = {
	color: ['ctaColor', 'headingColor', 'headingColorDesktop', 'copyColor', 'copyColorDesktop', 'backgroundColor'],
	number: [],
	json: ['contentIcon', 'imageDesktop', 'imageMobile', 'videoDesktop', 'videoMobile', 'ctaLink'],
};

<Meta
	title="Multi Column Layout"
	decorators={[defaultLayout]}
	component={BlockMultiColumnLayout}
	argTypes={addControls(argTypes, controls)}
/>

# Multi Column Layout

This module is used on various pages, such as the category page, since the layout is very flexible and customizable.

It is used basically to display some text and an image or video. Optionally an icon can be added above the text on desktop. The layout is very customizable, especially on desktop, so the image or video can take 100% of the width or 50% of the width and it can be positioned to the left (with the text on the right) or right (with the text on the left).

export const Template = (args, { argTypes }) => {
	initJsonKnobs(args, argTypes, controls.json);
	return {
		props: Object.keys(argTypes),
		components: { BlockMultiColumnLayout },
		template: '<block-multi-column-layout v-bind="$props" />',
		store,
	};
};

<Canvas withSource="none">
	<Story
		name="default"
		args={{
			contentBottom: [],
			contentIcon: {
				url:
					'https://images.prismic.io/molekule/5d3d5465-8629-4cdc-8bc0-79670da773c7_24.1+-+PM+Sensor+-+levels.svg?auto=compress,format',
				alt: null,
				copyright: null,
				width: 94,
				height: 10,
			},
			contentIconPosition: 'middle',
			contentMiddle:
				'<h2>A window into your air</h2><p>Air Mini+’s sensor rates air particle levels from “Good” to “Very bad,” offering a glance into your indoor air.</p>',
			contentTop: [],
			copyColor: 'light',
			critical: false,
			ctaColor: null,
			ctaHorizontalAlign: null,
			ctaLink: null,
			ctaText: null,
			ctaVariant: 'Outline',
			ctaVerticalPosition: null,
			imageDesktop: {},
			imageMobile: {},
			mediaTypeDesktop: 'video',
			mediaTypeMobile: 'video',
			textAlignDesktop: 'left',
			textAlignMobile: 'center',
			variantDesktop: 'full image, content 50% left',
			videoAspectRatioDesktop: 1.77,
			videoAspectRatioMobile: 1,
			videoDesktop: {
				name: 'Looping Dustbeam_V5.mp4',
				kind: 'document',
				url: 'https://molekule.cdn.prismic.io/molekule/e018d850-a7ec-4256-b48b-3c0b36b2e55a_Looping+Dustbeam_V5.mp4',
			},
			videoMobile: {
				name: 'Looping Dustbeam_V5.mp4',
				kind: 'document',
				url: 'https://molekule.cdn.prismic.io/molekule/e018d850-a7ec-4256-b48b-3c0b36b2e55a_Looping+Dustbeam_V5.mp4',
			},
			copyColor: '#000000',
			copyColorDesktop: '#ffffff',
		}}
	>
		{Template.bind({})}
	</Story>
</Canvas>

## Vue Component Props

<ArgsTable of={BlockMultiColumnLayout} />
